package com.qmth.ops.api.controller.admin;

import com.qmth.ops.api.constants.OpsApiConstants;
import com.qmth.ops.api.security.AdminSession;
import com.qmth.ops.biz.domain.Module;
import com.qmth.ops.biz.domain.Role;
import com.qmth.ops.biz.query.ModuleQuery;
import com.qmth.ops.biz.service.AppService;
import com.qmth.ops.biz.service.ModuleService;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestAttribute;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

@RestController
@RequestMapping(OpsApiConstants.ADMIN_URI_PREFIX + "/module")
public class ModuleController {

    @Resource
    private AppService appService;

    @Resource
    private ModuleService moduleService;

    @PostMapping("/insert")
    public Module insert(@RequestAttribute AdminSession accessEntity, Module module) {
        accessEntity.validateRole(Role.ADMIN, Role.DEV);
        return moduleService.insert(module);
    }

    @PostMapping("/update")
    public Module update(@RequestAttribute AdminSession accessEntity, Module module) {
        accessEntity.validateRole(Role.ADMIN, Role.DEV);
        return moduleService.update(module);
    }

    @PostMapping("/list")
    public List<Module> list(@RequestAttribute AdminSession accessEntity, ModuleQuery query) {
        accessEntity.validateApp(appService.getById(query.getAppId()));
        return moduleService.list(query);
    }

}
