package com.qmth.ops.api.dto;

import com.qmth.ops.biz.domain.Role;
import com.qmth.ops.biz.domain.User;
import org.springframework.validation.annotation.Validated;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

@Validated
public class UserForm {

    public interface LoginGroup {

    }

    public interface InsertGroup {

    }

    public interface UpdateGroup {

    }

    @NotNull(message = "id不能为空", groups = UpdateGroup.class)
    private Long id;

    @NotBlank(message = "loginName不能为空", groups = { InsertGroup.class, LoginGroup.class })
    private String loginName;

    @NotBlank(message = "name不能为空", groups = InsertGroup.class)
    private String name;

    @NotBlank(message = "password不能为空", groups = { InsertGroup.class, LoginGroup.class })
    private String password;

    @NotNull(message = "role不能为空", groups = InsertGroup.class)
    @Size(min = 1, message = "role不能为空", groups = InsertGroup.class)
    private Role[] role;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getLoginName() {
        return loginName;
    }

    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public Role[] getRole() {
        return role;
    }

    public void setRole(Role[] role) {
        this.role = role;
    }

    public User build() {
        User user = new User();
        user.setId(id);
        user.setLoginName(loginName);
        user.setName(name);
        user.setPassword(password);
        user.setRole(role);
        return user;
    }
}
