package com.qmth.ops.biz.domain;

public enum FileFormat {

    PROPERTY("properties"), JSON("json");

    private String extension;

    private FileFormat(String extension) {
        this.extension = extension;
    }

    public String getExtension() {
        return extension;
    }

    public static FileFormat findByExtension(String extension) {
        for (FileFormat format : values()) {
            if (format.getExtension().equalsIgnoreCase(extension)) {
                return format;
            }
        }
        return null;
    }
}
