package com.qmth.ops.biz.domain;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.handlers.JacksonTypeHandler;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.qmth.boot.tools.models.ByteArray;
import org.apache.commons.lang3.ArrayUtils;

import java.io.Serializable;

@TableName(value = "user", autoResultMap = true)
public class User implements Serializable {

    private static final long serialVersionUID = 3084261544687496032L;

    @TableId(type = IdType.AUTO)
    private Long id;

    private String loginName;

    private String name;

    @JsonIgnore
    private String password;

    @TableField(typeHandler = JacksonTypeHandler.class)
    private Role[] role;

    @JsonIgnore
    private String exportSecret;

    private Long createTime;

    private Long updateTime;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getLoginName() {
        return loginName;
    }

    public void setLoginName(String loginName) {
        this.loginName = loginName;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Role[] getRole() {
        return role;
    }

    public void setRole(Role[] role) {
        this.role = role;
    }

    public String getExportSecret() {
        return exportSecret;
    }

    public void setExportSecret(String exportSecret) {
        this.exportSecret = exportSecret;
    }

    public Long getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Long createTime) {
        this.createTime = createTime;
    }

    public Long getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Long updateTime) {
        this.updateTime = updateTime;
    }

    public String buildPassword(String input) {
        return ByteArray.md5(ByteArray.md5(input).toHexString() + "\t" + createTime.toString()).toHexString()
                .toLowerCase();
    }

    public String buildAccessToken() {
        return ByteArray.fromString(loginName + createTime).toBase64();
    }

    public boolean hasRole(Role... roles) {
        for (Role role : roles) {
            if (ArrayUtils.contains(this.role, role)) {
                return true;
            }
        }
        return false;
    }

}
