package com.qmth.ops.biz.service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.qmth.ops.biz.dao.AppUserDao;
import com.qmth.ops.biz.domain.App;
import com.qmth.ops.biz.domain.AppUser;
import com.qmth.ops.biz.domain.User;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import javax.validation.constraints.NotNull;
import java.util.List;

@Service
public class AppUserService extends ServiceImpl<AppUserDao, AppUser> {

    @Resource
    private AppUserDao appUserDao;

    public List<AppUser> listByApp(@NotNull App app) {
        return appUserDao.selectList(new LambdaQueryWrapper<AppUser>().eq(AppUser::getAppId, app.getId()));
    }

    public boolean exist(@NotNull App app, @NotNull User user) {
        return appUserDao.selectOne(new LambdaQueryWrapper<AppUser>().eq(AppUser::getAppId, app.getId())
                .eq(AppUser::getUserId, user.getId())) != null;
    }

    @Transactional
    public AppUser insert(@NotNull App app, @NotNull User user) {
        AppUser au = new AppUser(app.getId(), user.getId());
        appUserDao.insert(au);
        return au;
    }

    @Transactional
    public void delete(@NotNull App app, @NotNull User user) {
        appUserDao.delete(new LambdaQueryWrapper<AppUser>().eq(AppUser::getAppId, app.getId())
                .eq(AppUser::getUserId, user.getId()));
    }
}

