package com.qmth.ops.biz.utils;

import com.qmth.ops.biz.domain.ConfigItem;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.LinkedList;
import java.util.List;
import java.util.Properties;
import java.util.Set;

public class PropertyFileUtil {

    public static void write(List<ConfigItem> configList, OutputStream ous) throws IOException {
        Properties p = new Properties();
        for (ConfigItem item : configList) {
            p.put(item.getKey(), item.getValue());
        }
        p.list(new PrintStream(ous));
    }

    public static List<ConfigItem> read(InputStream ins) throws IOException {
        Properties p = new Properties();
        p.load(ins);
        Set<String> keys = p.stringPropertyNames();
        List<ConfigItem> list = new LinkedList<>();
        for (String key : keys) {
            ConfigItem item = new ConfigItem();
            item.setKey(key);
            item.setValue(p.getProperty(key));
            list.add(item);
        }
        return list;
    }
}